<template>
  <v-container>
    <v-row v-if="stripeError">
      <v-col cols="12">
        <p v-if="stripeError" class="stripeError">
          {{ stripeError }}
        </p>
      </v-col>
    </v-row>

    <v-row>
      <v-col cols="12" md="8" lg="6">
        <p class="body-1">Credit Card Number</p>
        <div id="card-number" />
        <span v-if="cardNumberError" class="help-block">
          {{ cardNumberError }}
        </span>
      </v-col>
    </v-row>

    <v-row>
      <v-col cols="4">
        <p class="body-1">Expiration</p>
        <div id="card-expiry" />
        <span v-if="cardExpiryError" class="help-block">
          {{ cardExpiryError }}
        </span>
      </v-col>
      <v-col cols="4">
        <p class="body-1">CVC</p>
        <div id="card-cvc" />
        <span v-if="cardCvcError" class="help-block">
          {{ cardCvcError }}
        </span>
      </v-col>
      <v-col cols="4">
        <p class="body-1">Billing Zip Code</p>
        <div id="card-postal-code" />
        <span v-if="cardPostalCodeError" class="help-block">
          {{ cardPostalCodeError }}
        </span>
      </v-col>
    </v-row>

    <v-row v-if="showCoupon" class="coupon">
      <v-col cols="12">
        <v-expansion-panels>
          <v-expansion-panel>
            <v-expansion-panel-header>Apply Coupon</v-expansion-panel-header>
            <v-expansion-panel-content>
              <v-row>
                <v-col xs="8" md="5" lg="5">
                  <v-text-field
                    v-model="coupon"
                    style="max-height: 50px;"
                    :disabled="!!discountedPrice"
                    label="Enter your coupon"
                    solo
                  ></v-text-field>
                </v-col>
                <v-col xs="4" md="4" lg="4">
                  <v-btn
                    :loading="applyCouponLoading"
                    :disabled="!coupon.length || !!discountedPrice"
                    @click="applyCoupon"
                    >Apply</v-btn
                  >
                </v-col>
                <v-col v-if="!!discountedPrice" cols="12">
                  <v-icon color="red">mdi-heart</v-icon
                  ><span> You get a better price</span>
                </v-col>
              </v-row>
            </v-expansion-panel-content>
          </v-expansion-panel>
        </v-expansion-panels>
      </v-col>
    </v-row>

    <v-row justify="center">
      <v-col cols="12">
        <p>{{ errorMsg }}</p>
        <v-btn
          large
          color="primary"
          dark
          class="mb-2"
          :loading="loading"
          @click="submitFormToCreateToken"
        >
          <span v-if="loading">processing...</span>
          <span v-if="!loading">{{ buttonLabel }}</span>
        </v-btn>
        <v-btn
            @click="cancel"
             class="ml-2 mb-2"
             large
             text
             dark
             color="secondary">
          Cancel
        </v-btn>
        <p class="caption">
          <v-icon style="margin-right: 8px" size="14">mdi-account-lock</v-icon
          >Anonymous, Safe & Secure.
        </p>
      </v-col>
      <v-col cols="12">
        <!-- <v-img src="@/assets/powered_by_stripe.png" max-width="120" style="margin-left: auto;margin-right: auto;"/> -->
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapGetters, mapState } from 'vuex'
import EventBus from '@/event-bus'

export default {
  props: {
    email: {
      type: String
    },
    showCoupon: {
      type: Boolean,
      default: true
    },
    buttonLabel: {
      type: String,
      default: 'Purchase'
    },
    paymentType: {
      type: String
    }
    // bookCircle: {
    //   type: Function
    // }
  },
  data() {
    return {
      valid: false,
      card: {
        cvc: '',
        number: '',
        expiry: '',
        postalcode: ''
      },
      errorMsg: '',
      discountedPrice: '',
      coupon: '',
      cardNumber: '',
      cardExpiry: '',
      cardCvc: '',
      cardPostalCode: '',
      stripe: null,

      stripeError: '',
      cardCvcError: '',
      cardExpiryError: '',
      cardNumberError: '',
      cardPostalCodeError: '',
      loading: false,
      applyCouponLoading: false
    }
  },
  computed: {
    ...mapGetters({}),
    ...mapState('authentication', ['user'])
  },
  watch: {
    paymentResponse(newValue) {
      if (newValue) this.loading = false
    },
    errorMsg(newValue) {
      if (newValue) this.loading = false
    }
  },
  mounted() {
    this.setUpStripe()
    if (this.user.card) {
      this.card.number = `xxxx-xxxx-xxxx-${this.user.card.last4}`
      this.card.expiry =
        this.user.card.exp_month + this.user.card.exp_month.exp_year
      this.card.postalcode = this.user.card.zip
    }
  },
  methods: {
    setUpStripe() {
      if (window.Stripe === undefined) {
        alert('Stripe V3 library not loaded!')
      } else {
        const style = {
          base: {
            color: '#32325d',
            fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
            fontSmoothing: 'antialiased',
            fontSize: '16px',
            '::placeholder': {
              color: '#aab7c4'
            }
          },
          invalid: {
            color: '#fa755a',
            iconColor: '#fa755a'
          }
        }

        const stripe = window.Stripe(
          'pk_test_mop3ocjrznpHUYk6slBrlS7r00UDclEGYL'
        )
        this.stripe = stripe

        const elements = stripe.elements()
        this.cardCvc = elements.create('cardCvc', style)
        this.cardExpiry = elements.create('cardExpiry', style)
        this.cardNumber = elements.create('cardNumber', style)
        this.cardPostalCode = elements.create('postalCode', style)

        this.cardCvc.mount('#card-cvc')
        this.cardExpiry.mount('#card-expiry')
        this.cardNumber.mount('#card-number')
        this.cardPostalCode.mount('#card-postal-code')

        this.listenForErrors()
      }
    },

    listenForErrors() {
      const vm = this

      this.cardNumber.addEventListener('change', event => {
        vm.toggleError(event)
        vm.cardNumberError = ''
        vm.card.number = event.complete
      })

      this.cardExpiry.addEventListener('change', event => {
        vm.toggleError(event)
        vm.cardExpiryError = ''
        vm.card.expiry = event.complete
      })

      this.cardCvc.addEventListener('change', event => {
        vm.toggleError(event)
        vm.cardCvcError = ''
        vm.card.cvc = event.complete
      })
    },

    toggleError(event) {
      if (event.error) {
        this.stripeError = event.error.message
      } else {
        this.stripeError = ''
      }
    },

    submitFormToCreateToken() {
      this.clearCardErrors()
      let valid = true
      // const regx = /^\w+([-]?\w+)*@\w+([-]?\w+)*(\.\w{2,3})+$/

      // if (!regx.test(this.receiptEmail)) {
      //   valid = false
      //   this.$store.dispatch('payments/emailError', 'Email is not valid')
      // } else {
      //   this.$store.commit('payments/setEmailError', '')
      // }

      if (this.paymentType) {
        valid = true
      }

      if (!this.card.number) {
        valid = false
        this.cardNumberError = 'Card Number is Required'
      }
      if (!this.card.cvc) {
        valid = false
        this.cardCvcError = 'CVC is Required'
      }
      if (!this.card.expiry) {
        valid = false
        this.cardExpiryError = 'Month is Required'
      }

      if (this.stripeError) {
        valid = false
      }

      if (valid) {
        this.valid = true
        this.createToken()
      }
    },

    createToken() {
      const { totalPrice, discountedPrice, selectedPlan, receiptEmail } = this
      if (!this.valid) return

      this.loading = true
      this.stripe.createToken(this.cardNumber).then(async result => {
        if (result.error) {
          this.stripeError = result.error.message
          this.loading = false
        } else {
          if (this.paymentType === 'add') {
            await this.addCard(result)
            return
          }
          if (this.paymentType === 'bookCircle') {
            await this.addCard(result)
            EventBus.$emit('callBookCircle', true)
            return
          }
          const token = result.token.id
          const charge = {
            token,
            totalPrice,
            discountedPrice,
            plan: selectedPlan,
            email: receiptEmail
          }

          this.$store
            .dispatch('payments/createChargeWithStripe', charge)
            .then(() => {
              this.reset()
            })
            .catch(err => {
              console.log(err)
              this.loading = false
            })
        }
      })
    },
    async addCard(result) {
      const data = {
        token: result.token.id,
        last4: result.token.card.last4,
        exp_month: result.token.card.exp_month,
        exp_year: result.token.card.exp_year,
        brand: result.token.card.brand,
        country: result.token.card.country,
        cvc_check: result.token.card.cvc_check,
        zip: result.token.card.address_zip
      }
      await this.$store.dispatch('authentication/addUserStripeToken', data)
      this.loading = false
    },
    clearElementsInputs() {
      this.cardCvc.clear()
      this.cardExpiry.clear()
      this.cardNumber.clear()
    },

    clearCardErrors() {
      this.stripeError = ''
      this.cardCvcError = ''
      this.cardExpiryError = ''
      this.cardNumberError = ''
    },

    reset() {
      this.clearElementsInputs()
      this.clearCardErrors()
    },

    applyCoupon() {
      this.applyCouponLoading = true
      this.$store
        .dispatch('payments/checkCouponCode', {
          code: this.coupon
        })
        .then(() => {
          this.applyCouponLoading = false
        })
    },

    cancel() {
      EventBus.$emit('cancel-payment')
    }
  }
}
</script>

<style lang="scss">
.StripeElement {
  box-sizing: border-box;
  font-size: 18px;
  height: 45px;

  padding: 10px 12px;

  border: 1px solid #c2c2c2;
  border-radius: 4px;
  background-color: white;

  // box-shadow: 0 1px 3px 0 #e6ebf1;
  // -webkit-transition: box-shadow 150ms ease;
  // transition: box-shadow 150ms ease;
}

.StripeElement--focus {
  box-shadow: 0 1px 3px 0 #cfd7df;
}

.StripeElement--invalid {
  border-color: #fa755a;
}

.StripeElement--webkit-autofill {
  background-color: #fefde5 !important;
}

.help-block {
  color: red;
  font-size: 13px;
}

#card-number,
#card-cvc,
#card-expiry {
  padding-top: 10px;
}

.stripeError {
  color: red;
  font-style: italic;
}
.coupon {
  button.v-btn {
    height: 49px !important;
    font-size: 0.8rem;
  }
}
@media screen and (max-width: 742px) {
  .stripe-form {
    .sub-title {
      font-size: 0.5rem;
    }
  }
}
</style>
